%error = forceRequiredAddOn("Gamemode_TeamDeathmatch"); //Needed to run game modes
if(%error == $Error::AddOn_NotFound)
{
	error("Gamemode_Reactor - required Add-On Gamemode_TeamDeathmatch not found");
	return;
}

registerGameMode("Reactor","RTR",1,0,0);
setGameModeHelp("Reactor","Add-Ons/Gamemode_Reactor/rules.txt");
addGameModeRule("Reactor","TimeLimit","int 0 10",0);
addGameModeRule("Reactor","ReactorHealth","int 1 5000",0);

function GameMode_RTR_onModeStart(%mini,%client)
{
	if(%mini.TeamExists2 || !%mini.TeamExists1)
	{
		serverCmdEndMiniGame(%client);
		messageClient(%client,'',"Error: Reactor must be played with 2 teams.");
		return;
	}
	$maxhelf = %mini.tdmModeRule[1];
	if(%mini.tdmModeRule[0] != 0)
	{
		$tehTiemz = %mini.tdmModeRule[0] @ ":00";
		$tehRealTiemz = %mini.tdmModeRule[0]*60;
		$uezTiemz = 1;
	}
	else
	{
		$tehTiemz = "";
		$uezTiemz = 0;
	}
	_RT0.h = %mini.tdmModeRule[1];
	_RT1.h = %mini.tdmModeRule[1];
	StartReactorTime(%mini);
	for(%i=0;%i<%mini.numMembers;%i++)
	{
		%c = %mini.member[%i];
		%c.ReactorStats();
	}
}

function GameMode_RTR_onMiniReset(%mini,%client)
{
	cancel($tiemzsced);
	for(%i=0;%i<%mini.numMembers;%i++)
	{
		%c = %mini.member[%i];
		%c.schedule(100,ReactorStats);
	}
	GameMode_RTR_onModeStart(%mini,%client);
}

function startReactorTime(%mini)
{
	if(!$uezTiemz)
		return;
	$tiemzsced = schedule(1000,0,ReactorTime,%mini);
}

function ReactorTime(%mini)
{
	cancel($tiemzsced);
	if(!$uezTiemz)
		return;
	$tehRealTiemz--;
	%min = mFloor($tehRealTiemz/60);
	%sec = $tehRealTiemz-(%min*60);
	if(strLen(%sec) == 2)
		$tehTiemz = %min @ ":" @ %sec;
	else
		$tehTiemz = %min @ ":0" @ %sec;
	for(%i=0;%i<%mini.numMembers;%i++)
	{
		%c = %mini.member[%i];
		%c.ReactorStats();
	}
	if($tehRealTiemz == 0)
	{
		GameMode_RTR_onTimeLimit(%mini);
		return;
	}
	$tiemzsced = schedule(1000,0,ReactorTime,%mini);
}
		

function GameConnection::ReactorStats(%c)
{
	if(isObject(%p=%c.player))
	{
		%d=%p.dataBlock;
		if(%c.tdmteam == 0)
		{
			%r=_RT0.h;
			%v="<color:ff0000>";
			%e=_RT1.h;
			%q="<color:0000ff>";
		}
		else
		{
			%r=_RT1.h;
			%v="<color:0000ff>";
			%e=_RT0.h;
			%q="<color:ff0000>";
		}
		commandToClient(%c,'CenterPrint',"<just:right><color:00ff00>" @ mFloatLength(%d.MaxDamage-%p.getDamageLevel(),1) @ "/" @ %d.maxDamage NL %v @ %r @ "/" @ $maxhelf @ " <color:ffffff>- " @ %q @ %e @ "/" @ $maxhelf NL "<color:ffff00>" @ $tehtiemz,-1,10);
	}
}

function GameMode_RTR_onReactorDestroyed(%mini,%rt)
{
	cancel($tiemzsced);
	if(%mini.roundWon)
		return;
	%mini.roundWon = 1;
	%team = teamName(%mini,!%rt);
	messageAll('','%1 \c6won this round! (Reactor Destroyed)',%team);
	for(%i=0;%i<%mini.numMembers;%i++)
	{
		%cl = %mini.member[%i];
		if(%cl.tdmTeam != %rt)
		{
			if(isObject(%cl.player) && %cl.player.getState() !$= "Dead")
				%cl.player.emote(winStarProjectile,1);
			%cl.tdmRoundsWon++;
			%cl.play2d(BattleSwarm_Win);
		}
		else
		{
			%cl.play2d(BattleSwarm_Reactor_Destroyed);
			%cl.play2d(BattleSwarm_Lose);
		}
		if(isObject(%cl.player))
		{
			%cl.setControlObject(%cl.camera);
			%cl.camera.setMode("Corpse",%cl.player);
			%cl.tdmCameraTarget = 0;
		}
		else
			%cl.getAutoCameraTarget();
	}
	%mini.schedule(5000,reset,%mini.owner);
}

function GameMode_RTR_onTimeLimit(%mini)
{
	cancel($tiemzsced);
	if(%mini.roundWon)
		return;
	%mini.roundWon = 1;
	if(_RT0.h == _RT1.h)
		%win = -1;
	else if(_RT0.h > _RT1.h)
		%win = 0;
	else
		%win = 1;
	if(%win == -1)
		messageAll('',"\c6Round tied. (Time expired)");
	else
	{
		%rt = !%win;
		%team = teamName(%mini,!%rt);
		messageAll('','%1 \c6won this round! (Time expired)',%team);
		for(%i=0;%i<%mini.numMembers;%i++)
		{
			%cl = %mini.member[%i];
			if(%cl.tdmTeam != %rt)
			{
				if(isObject(%cl.player) && %cl.player.getState() !$= "Dead")
					%cl.player.emote(winStarProjectile,1);
				%cl.tdmRoundsWon++;
				%cl.play2d(BattleSwarm_Win);
			}
			else
				%cl.play2d(BattleSwarm_Lose);
		}
	}
	for(%i=0;%i<%mini.numMembers;%i++)
	{
		%cl = %mini.member[%i];
		if(isObject(%cl.player))
		{
			%cl.setControlObject(%cl.camera);
			%cl.camera.setMode("Corpse",%cl.player);
			%cl.tdmCameraTarget = 0;
		}
		else
			%cl.getAutoCameraTarget();
	}
	%mini.schedule(5000,reset,%mini.owner);
}

package REACTOR
{
	function fxDtsBrick::onProjectileHit(%b,%p,%c)
	{
		if(%b.getName() $= "_RT0" || %b.getName() $= "_RT1")
		{
			%t = getSubStr(%b.getName(),3,1);
			if(%t == %p.client.tdmteam)
				return Parent::onProjectileHit(%b,%p,%c);
			%mini = MinigameGroup.getObject(0);
			%b.h-=(%p.dataBlock.DirectDamage+%p.dataBlock.explosion.RadiusDamage)*%p.scale;
			if(%b.h <= 0)
			{
				%b.h = 0;
				%b.fakeKillBrick("0 0 10",6,%c);
				%b.spawnExplosion(RocketLauncherProjectile,3,%c);
				GameMode_RTR_onReactorDestroyed(%mini,%t);
				for(%i=0;%i<%mini.numMembers;%i++)
				{
					%c = %mini.member[%i];
					%c.ReactorStats();
				}
				return Parent::onProjectileHit(%b,%p,%c);
			}
			for(%i=0;%i<%mini.numMembers;%i++)
			{
				%c = %mini.member[%i];
				%c.ReactorStats();
				if(getSimTime()-%b.timeoutBUA >= 5000 && %c.tdmteam == %t)
				{
					messageClient(%c,'',"<color:ffffff>Base is under attack!");
					%c.play2d(BattleSwarm_Base_Attacked);
					%b.timeoutBUA = getSimTime();
				}
			}
		}
		return Parent::onProjectileHit(%b,%p,%c);
	}
	function fxDtsBrick::timeoutBUA(%this)
	{
		%this.timeoutBUA = 0;
	}
	function Armor::onDamage(%d,%p,%a)
	{
		%p.client.ReactorStats();
		return Parent::onDamage(%d,%p,%a);
	}
};
activatePackage(REACTOR);